import React, { Component } from 'react'
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';

import { signInRequest } from './../../actions/auth/signIn'
import { signUpRequest } from './../../actions/auth/signUp'

import { auth, googleAuthProvider } from '../../firebase_config'

class AuthPage extends Component {
    constructor(props) {
        super(props);
        this.state = {
            user: null
        }
    }

    componentDidMount() {
        auth.onAuthStateChanged(user => this.setState({ user }))
    }

    authRequest = () => {
        auth.signInWithPopup(googleAuthProvider)
            .then(res => {
                console.log(res);

                this.setState({
                    user: res.user
                })
            })
    }

    render() {
        const { } = this.props; // 
        const { user } = this.state; // 

        console.log("<AuthPage> - props", this.props);


        return (
            <div className="auth-page">
                <h1>{user && user.displayName}</h1>
                <button onClick={this.authRequest} disabled={user ? true : false}>Auth</button>
            </div>
        )
    }
}

const
    mapStateToProps = state => ({
        signInState: {
            ...state.signIn
        },
        signUpState: {
            ...state.signUp
        }
    }),
    mapDispatchToProps = dispatch => bindActionCreators({ signInRequest, signUpRequest }, dispatch);

export default connect(mapStateToProps, mapDispatchToProps)(AuthPage)